if(!NU){var NU={};}
NU.ooeg={
    "version":"Time-stamp: <2013-02-03 12:44:32 nous>",
    "publ":{"clas":{},"func":{},"cons":{}},
    "priv":{"clas":{},"func":{},"cons":{}}
};

NU.ooeg.publ.cons.src_blue="./img/face-b.png";
NU.ooeg.publ.cons.src_red="./img/face-r.png";
NU.ooeg.publ.cons.src_null="./img/null.png";
NU.ooeg.publ.cons.src_frame="./img/edge-g.png";
NU.ooeg.publ.cons.src_highlight="./img/edge-y.png";
NU.ooeg.publ.cons.src_highlightface="./img/face-y.png";

NU.ooeg.publ.func.createNewBoardAt = function(pare,ai_list,size){
    var board;
//    board = new NU.ooeg.priv.clas.MainElement(6,8);
    board = new NU.ooeg.priv.clas.MainElement(size[0],size[1],ai_list);
    pare.appendChild(board.getHtmlElement());
    return board;
};

NU.ooeg.publ.func.createListOfAI_MOCA = function(list_paras){
    var ai_list,i;
    ai_list=[];
    for(i=0;i<list_paras.length;i++){
	ai_list[i]=new NU.ooeg.priv.clas.MOCA(list_paras[i][0],list_paras[i][1]);
    }
    return ai_list;
};

/* ************************************************ */
NU.ooeg.priv.func.getCopiedDict =function(dict){
    var i,r;
    r={};
    for(i in dict){
	r[i]=dict[i];
    }
    return r;
};
NU.ooeg.priv.func.getCopiedArray =function(arra,ii){
    var i,r;
    r=[];
    for(i=0;i<arra.length;i++){
	if(i!=ii){
	    r[r.length]=arra[i];
	}
    }
    return r;
};




NU.ooeg.priv.func.isAnElement= function(elm,lis){
    var i;
    for(i=0;i<lis.length;i++){
	if(elm==lis[i]){
	    return true;
	}
    }
    return false;
};

NU.ooeg.priv.func.appendIfNotExists=function(elm,lis){
    if(NU.ooeg.priv.func.isAnElement(elm,lis)){

    }else{
	lis[lis.length]=elm;
    }
};

NU.ooeg.priv.func.appendElementsIfNotExists =function(elms,lis){
    var i;
    for(i in elms){
	NU.ooeg.priv.func.appendIfNotExists(elms[i],lis);
    }
};

NU.ooeg.priv.func.getCellString =function(cell){
    var r,i;
    r="|";
    for(i=0;i<cell.length;i++){
	r=r+cell[i]+"|";
    }
    return r;
};



NU.ooeg.priv.clas.Polyhedron = function(faces,face_as_edges,face_as_vertices,face_as_coordinate){
    var self,i;
    self=this;
    this.face_as_vertices=NU.ooeg.priv.func.getCopiedDict(face_as_vertices);
    var vertices;
    vertices=[];
    for(i in face_as_vertices){
	NU.ooeg.priv.func.appendIfNotExists(face_as_vertices[i],vertices);
    }
    this.vertices=vertices;
    this.face_as_edges=NU.ooeg.priv.func.getCopiedDict(face_as_edges);
    var edges;
    edges=[];
    for(i in face_as_edges){
	NU.ooeg.priv.func.appendIfNotExists(face_as_edges[i],edges);
    }
    this.edges=edges;
    this.faces=NU.ooeg.priv.func.getCopiedArray(faces);
    this.face_as_coordinate=NU.ooeg.priv.func.getCopiedDict(face_as_coordinate);

    this.get_copied_polyhedron =function(){
        return new NU.ooeg.priv.clas.Polyhedron(this.faces,this.face_as_edges,this.face_as_vertices,this.face_as_coordinate);
    };

    this.get_euler_characteristic_of = function(faces){
	var i;
	var all_faces,set_faces,set_edges,set_vertices;
	all_faces=this.faces;
	set_faces=[];
	set_edges=[];
	set_vertices=[];

	for(i=0;i<faces.length;i++){
	    if(NU.ooeg.priv.func.isAnElement(faces[i],all_faces)){
		NU.ooeg.priv.func.appendIfNotExists(faces[i],set_faces);
		NU.ooeg.priv.func.appendElementsIfNotExists(this.face_as_vertices[faces[i]],set_vertices);
		NU.ooeg.priv.func.appendElementsIfNotExists(this.face_as_edges[faces[i]],set_edges);
	    }
	}
        return set_vertices.length - set_edges.length + set_faces.length;
    }
};



NU.ooeg.priv.clas.Board = function(polyhedron,cells_eachplayer,n_turn){
    var self;
    self=this;
    this.polyhedron=polyhedron.get_copied_polyhedron();
    this.cells=[];
    this.cells[0]=NU.ooeg.priv.func.getCopiedArray(cells_eachplayer[0]);
    this.cells[1]=NU.ooeg.priv.func.getCopiedArray(cells_eachplayer[1]);

    this.n_turn=n_turn;

    this.get_copied_board= function(){
        return new NU.ooeg.priv.clas.Board(this.polyhedron,this.cells,this.n_turn);
    };

    this.get_point=function(player){
        return this.polyhedron.get_euler_characteristic_of(this.cells[player]);
    };

    this.get_all_cells = function(){
        return this.polyhedron.faces;
    };

    this.get_empty_cells = function(){
	var r,i,cells;
	r=[];
        cells=this.get_all_cells();
	for(i=0;i<cells.length;i++){
	    if(this.get_owner_of(cells[i]) < 0){
		r[r.length]=cells[i];
	    }
	}
        return r;
    };

    this.n_empty_cells = function(){
	var n,cells,i;
	n=0;
        cells=this.get_all_cells();
	for(i=0;i<cells.length;i++){
	    if(this.get_owner_of(cells[i]) < 0){
		n++;
	    }
	}
	return n;
    };

    this.get_an_empty_cell_at=function(n){
	var nn,cells,i;
	nn=n;
        cells=this.get_all_cells();
        for(i=0;i<cells.length;i++){
            if(this.get_owner_of(cells[i]) < 0){
                nn == nn-1;
                if(nn < 0){
                    return cells[i];
		}
	    }
	}
        return this.get_an_empty_cell_at(n%(n-nn));
    };

    this.get_owner_of = function(cell){
	if(NU.ooeg.priv.func.isAnElement(cell,this.cells[0])){
	    return 0;
	}
	if(NU.ooeg.priv.func.isAnElement(cell,this.cells[1])){
	    return 1;
	}
	return -1;
    }

    this.get_winner = function(){
        if(this.get_point(0) > this.get_point(1)){
            return 0;
        }else{
            return 1;
	}
    };

    this.append_cell = function(player,cell){
        this.cells[player][this.cells[player].length]=cell;
    };

    this.get_coordinate = function(cell){
	return NU.ooeg.priv.func.getCopiedArray(this.polyhedron.face_as_coordinate[cell]);
    };
};




NU.ooeg.priv.clas.Referee=function(board,player1_is_ai,player2_is_ai,boardelm){
    var self;
    self=this;
    this.board=board.get_copied_board();
    this.player_is_ai=[player1_is_ai,player2_is_ai];
    this.timer=0;
    this.boardelm=boardelm;
    this.is_waiting_input=0;

    this.start_game=function(){
	this.is_waiting_input=0;
	this.boardelm.setPoint(this.board.get_point(0),this.board.get_point(1));
	this.timer=setTimeout(function(){self.start_turn();},1);
    };
    this.start_turn=function(){
	if(this.board.n_empty_cells()>0){
	    if(this.player_is_ai[this.board.n_turn%2]<0){
		this.start_waiting_input();
	    }else{
		this.ai_turn(this.boardelm.ai_list[this.player_is_ai[this.board.n_turn%2]]);
	    }
	}else{
	    this.end_game();
	}
    };
    this.start_waiting_input=function(){
	this.is_waiting_input=1;
	this.boardelm.setTurn(this.board.n_turn % 2);
    };

    this.input_and_continue=function(cell){
	if(this.is_waiting_input>0){
	    this.is_waiting_input=0;
	    if(this.board.get_owner_of(NU.ooeg.priv.func.getCellString(cell)) < 0){

		this.board.append_cell(this.board.n_turn % 2,NU.ooeg.priv.func.getCellString(cell));
		this.boardelm.putcell(cell,this.board.n_turn % 2);
		this.end_turn();
		return;
	    }else{
		this.is_waiting_input=1;
		return;
	    }
	}
    };
    this.end_turn = function(){
	this.is_waiting_input=0;

	this.boardelm.setPoint(this.board.get_point(0),this.board.get_point(1));
	this.board.n_turn++;
	this.boardelm.setTurn(-1);
	this.timer=setTimeout(function(){self.start_turn();},250);

    };

    this.ai_turn = function(ai){
	this.is_waiting_input=0;
	this.boardelm.setTurn(-1);
	var candidate,c;
	candidate=this.board.get_empty_cells();
	c=ai.play(this.board.get_copied_board(),NU.ooeg.priv.func.getCopiedArray(candidate));
	this.board.append_cell(this.board.n_turn % 2,candidate[c]);
	this.boardelm.putcell(this.board.get_coordinate(candidate[c]),this.board.n_turn % 2);
	this.end_turn();
    };
};

NU.ooeg.priv.clas.MOCA = function(n_step,penaltyforwinwithoutthecell){
    this.withoutp=penaltyforwinwithoutthecell;


    this.numofsim=n_step;
    this.play = function(board,candidate){
	var emptycells,tempboard;
	var n_win,n_lose;
	n_win={};
	n_lose={};
	var i,j,f,w,myturn;
	myturn=board.n_turn % 2;
	for(i=0;i<candidate.length;i++){
	    n_win[candidate[i]]=0.0;
	    n_lose[candidate[i]]=0.0;
	}
	for(j=0;j<this.numofsim;j++){
	    for(i=0;i<candidate.length;i++){
		tempboard=board.get_copied_board();
		tempboard.append_cell(tempboard.n_turn%2,candidate[i]);
		tempboard.n_turn++;
		emptycells=NU.ooeg.priv.func.getCopiedArray(candidate,i);
		while(emptycells.length>0){
		    f=Math.floor(Math.random()*emptycells.length);
		    tempboard.append_cell(tempboard.n_turn%2,emptycells[f]);
		    tempboard.n_turn++;
		    emptycells=NU.ooeg.priv.func.getCopiedArray(emptycells,f);
		}
		w=tempboard.get_winner();
		if(w==myturn){
		    n_win[candidate[i]]=1.0+n_win[candidate[i]];
		}else{
		    n_lose[candidate[i]]=1.0+n_lose[candidate[i]];
		}
		for(f=0;f<candidate.length;f++){
		    if(tempboard.get_owner_of(candidate[f])==myturn){
			if(w==myturn){
			    n_win[candidate[f]]=1.0+n_win[candidate[f]];
			}else{
			    n_lose[candidate[f]]=1.0+n_lose[candidate[f]];
			}
		    }else{
			if(w==myturn){
			    n_lose[candidate[f]]=this.withoutp+n_lose[candidate[f]];
			}else{
			    n_win[candidate[f]]=this.withoutp+n_win[candidate[f]];
			}
		    }
		}
		
	    }
	}
	var r,vr,cr;
	vr=0;
	r=0;

	for(i=0;i<candidate.length;i++){
	    cr=n_win[candidate[i]]/(n_win[candidate[i]]+n_lose[candidate[i]]);
	    if(vr<cr){
		r=i;
		vr=cr;
	    }
	}
	return r;

    };
};


NU.ooeg.priv.clas.P2Polyhedron = function(sizeX,sizeY){
    this.sizeX=sizeX;
    this.sizeY=sizeY;

    this.getEquvCell = function(cell){
	if(cell[0]<this.sizeY && cell[1]<this.sizeX){
	    return [cell[0]%this.sizeY,cell[1]%this.sizeX];
	}
	if(cell[1]==0){
	    return [this.sizeY,0];
	}
	if(cell[1]==this.sizeX){
	    return [this.sizeY-cell[0],0];
	}
	if(cell[0]==this.sizeY){
	    return [0,this.sizeX-cell[1]];
	}
    }
    var board,faces,face_as_edges,face_as_vertices,face_as_coordinate;
    var i,j,k,f,la;
    faces=[];
    face_as_coordinate={};
    faces[0]=NU.ooeg.priv.func.getCellString(this.getEquvCell([sizeY,0]));
    face_as_coordinate[faces[0]]=this.getEquvCell([sizeY,0]);
    for(j=0;j<sizeX;j++){
	for(i=0;i<sizeY;i++){
	    faces[faces.length]=NU.ooeg.priv.func.getCellString(this.getEquvCell([i,j]));
	    face_as_coordinate[faces[faces.length-1]]=this.getEquvCell([i,j]);
	}
    }
    
    face_as_edges={};
    for(i=0;i<faces.length;i++){
	face_as_edges[faces[i]]=[];
    }
    k=0;
    for(i=0;i<sizeY;i++){
	for(j=0;j<sizeX;j++){
	    la="e"+k;
	    k=k+1;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i,j]));
	    face_as_edges[f][face_as_edges[f].length]=la;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i+1,j]));
	    face_as_edges[f][face_as_edges[f].length]=la;

	    la="e"+k;
	    k=k+1;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i,j+1]));
	    face_as_edges[f][face_as_edges[f].length]=la;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i+1,j]));
	    face_as_edges[f][face_as_edges[f].length]=la;

	    la="e"+k;
	    k=k+1;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i+1,j]));
	    face_as_edges[f][face_as_edges[f].length]=la;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i+1,j+1]));
	    face_as_edges[f][face_as_edges[f].length]=la;
	}
    }


    face_as_vertices={};
    for(i=0;i<faces.length;i++){
	face_as_vertices[faces[i]]=[];
    }

    for(i=0;i<sizeY;i++){
	for(j=0;j<sizeX;j++){
	    la="v"+k;
	    k=k+1;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i,j]));
	    face_as_vertices[f][face_as_vertices[f].length]=la;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i+1,j]));
	    face_as_vertices[f][face_as_vertices[f].length]=la;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i,j+1]));
	    face_as_vertices[f][face_as_vertices[f].length]=la;

	    la="v"+k;
	    k=k+1;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i+1,j]));
	    face_as_vertices[f][face_as_vertices[f].length]=la;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i+1,j+1]));
	    face_as_vertices[f][face_as_vertices[f].length]=la;
	    f=NU.ooeg.priv.func.getCellString(this.getEquvCell([i,j+1]));
	    face_as_vertices[f][face_as_vertices[f].length]=la;
	}
    }
    
    this.polyhedron=new NU.ooeg.priv.clas.Polyhedron(faces,face_as_edges,face_as_vertices,face_as_coordinate);
}


NU.ooeg.priv.clas.MainElement = function(sizeX,sizeY,ai_list){
    var self;
    self = this;
    var w,h;
    w=1;
    h=1;

    this.p2polyhedron=new NU.ooeg.priv.clas.P2Polyhedron(sizeX,sizeY);

    this.pointelm=[];
    this.turnelm=[];
    this.mainrootelm=document.createElement("div");
    this.mainrootelm.style.borderColor="#E7E7EB";
    this.mainrootelm.style.borderWidth='20px';
    this.mainrootelm.style.borderStyle='solid';
    this.mainrootelm.style.position='relative';


    this.rootelm = document.createElement("div");
    this.mainrootelm.appendChild(this.rootelm);
    this.rootelm.style.borderColor="#FFFFFF";
    this.rootelm.style.borderWidth='20px';
    this.rootelm.style.borderStyle='solid';
    this.rootelm.style.position='relative';

    this.backgroundelm=document.createElement("div");
    this.backgroundelm.style.position='absolute';
    this.backgroundelm.style.left='0px';
    this.backgroundelm.style.top='0px';
    this.backgroundelm.style.borderColor="red";
    this.backgroundelm.style.borderWidth='0px';
    this.backgroundelm.style.borderStyle='solid';
    
    this.rootelm.appendChild(this.backgroundelm);

    this.displayelm=document.createElement("div");
    this.displayelm.style.position='absolute';
    this.displayelm.style.left='0px';
    this.displayelm.style.top='0px';
    this.displayelm.style.borderColor="red";
    this.displayelm.style.borderWidth='0px';
    
    this.rootelm.appendChild(this.displayelm);


	
    this.touchpanelelm=document.createElement("div");
    this.touchpanelelm.style.position='absolute';
    this.touchpanelelm.style.left='0px';
    this.touchpanelelm.style.top='0px';
    this.touchpanelelm.style.borderWidth='0px';
    this.touchpanelelm.style.borderColor="red";
    this.touchpanelelm.style.borderStyle="solid";

    this.rootelm.appendChild(this.touchpanelelm);


    var itemroot,tbl,tr,td,item;
    itemroot=document.createElement("div");
    itemroot.style.borderColor="red";
    itemroot.style.borderWidth='0px';
    itemroot.style.borderStyle='solid';
    this.backgroundelm.appendChild(itemroot);

    tbl=document.createElement("table");
    tbl.style.marginLeft="auto";
    tbl.style.marginRight="2px";

    itemroot.appendChild(tbl);

    tr=document.createElement("tr");
    tbl.appendChild(tr);

    td=document.createElement("td");
    td.style.width="15px";
    tr.appendChild(td);
    item=document.createElement("img");
    item.setAttribute("src",NU.ooeg.publ.cons.src_highlight);
    item.style.width="15px";
    this.turnelm[0]=item;
    td.appendChild(item);

    td=document.createElement("td");
    tr.appendChild(td);
    item=document.createElement("img");
    item.setAttribute("src",NU.ooeg.publ.cons.src_blue);
    item.style.height="40px";
    td.appendChild(item);


    td=document.createElement("td");
    td.style.textAlign="right";
    td.style.fontSize="35px";
    td.style.minWidth="1em";
    tr.appendChild(td);

    item=document.createElement("span");
    this.pointelm[0]=item;
    td.appendChild(item);
    

    tr=document.createElement("tr");
    tbl.appendChild(tr);

    td=document.createElement("td");
    td.style.width="15px";
    tr.appendChild(td);
    item=document.createElement("img");
    item.setAttribute("src",NU.ooeg.publ.cons.src_highlight);
    item.style.width="15px";
    this.turnelm[1]=item;
    td.appendChild(item);


    td=document.createElement("td");
    tr.appendChild(td);
    item=document.createElement("img");
    item.setAttribute("src",NU.ooeg.publ.cons.src_red);
    item.style.height="40px";
    td.appendChild(item);

    td=document.createElement("td");
    td.style.textAlign="right";
    td.style.fontSize="35px";
    td.style.minWidth="1em";
    tr.appendChild(td);

    item=document.createElement("span");
    this.pointelm[1]=item;
    td.appendChild(item);
    

	
    var map;
    map=document.createElement("map");
    map.setAttribute("name","numap")
    this.rootelm.appendChild(map);

    var i,j,cx,cy,img;
    var topm, leftm, skipstretch;
    topm=0;
    leftm=0;
    skipstretch=0.0;/*0 to 1 */

    var l,r,t,b;
    l=0;
    r=w;
    t=0;
    b=h;
    var imgelm;
    imgelm=[]
    for(i=0;i<sizeY+1;i++){
//	cy = (55+7.8)*i;
	cy = (45+(10+7.8)*skipstretch)*i+(30+10*skipstretch) +topm;
	imgelm[i]=[];
	for(j=0;j<sizeX+1;j++){
	    cx=(52+18*skipstretch)*j+(i+1)*(26+9*skipstretch)+leftm;
	    img=new NU.ooeg.priv.clas.CellElement(cx,cy,this.p2polyhedron.getEquvCell([i,j]),this);
	    this.displayelm.appendChild(img.getHtmlElement());
	    map.appendChild(img.getAreaElement());
	    
	    if(l>img.getMinX()){
		l=img.getMinX();
	    }
	    if(r<img.getMaxX()){
		r=img.getMaxX();
	    }
	    if(t>img.getMinY()){
		t=img.getMinY();
	    }
	    if(b<img.getMaxY()){
		b=img.getMaxY();
	    }
	    imgelm[i][j]=img;
	}
    }

    for(i=0;i<sizeY;i++){
	imgelm[i][0].appendEquivalentCell(imgelm[sizeY-i][sizeX]);
	imgelm[sizeY-i][sizeX].appendEquivalentCell(imgelm[i][0]);
    }
    for(j=0;j<sizeX+1;j++){
	imgelm[0][j].appendEquivalentCell(imgelm[sizeY][sizeX-j]);
	imgelm[sizeY][sizeX-j].appendEquivalentCell(imgelm[0][j]);
    }
   
    var img;
    w=(r-l);
    h=(b-t);
    img=document.createElement("img");
    img.setAttribute("src",NU.ooeg.publ.cons.src_null);
//    img.setAttribute("draggable",false);
    img.style.position="absolute";
    img.style.left=l+"px";
    img.style.top=t+"px";
    img.style.height=h+"px";
    img.style.width=w+"px";
    img.style.zIndex=100;
    img.style.borderWidth='0px';
    img.style.borderColor="red";
    img.style.borderStyle="solid";
    img.setAttribute("usemap","#numap");


    
    
    this.mainrootelm.style.height=(h+40)+"px";
    this.mainrootelm.style.width=(w+40)+"px";
    this.rootelm.style.height=h+"px";
    this.rootelm.style.width=w+"px";
    this.backgroundelm.style.height=h+"px";
    this.backgroundelm.style.width=w+"px";
    this.displayelm.style.height=h+"px";
    this.displayelm.style.width=w+"px";
    this.touchpanelelm.style.height=h+"px";
    this.touchpanelelm.style.width=w+"px";





    this.imgelm=imgelm;
    this.putcell = function(cell,color){
	var i,j;
	i=cell[0];
	j=cell[1];
	this.imgelm[i][j].setcolorall(color);
    };

    this.setPoint = function(p0,p1){
	this.pointelm[0].innerText=p0;
	this.pointelm[1].innerText=p1;
	this.pointelm[0].innerHTML=p0;
	this.pointelm[1].innerHTML=p1;
    };

    this.setTurn = function(player){
	switch(player){
	case 0:
	    this.turnelm[0].style.visibility="visible";
	    this.turnelm[1].style.visibility="hidden";
	    break;
	case 1:
	    this.turnelm[1].style.visibility="visible";
	    this.turnelm[0].style.visibility="hidden";
	    break;
	case -1:
	    this.turnelm[1].style.visibility="hidden";
	    this.turnelm[0].style.visibility="hidden";
	    break;
	default:
	    break;
	}

    };

    this.touchpanelelm.appendChild(img);

    this.getHtmlElement = function(){
	return this.mainrootelm;	
    };

    this.setPoint(0,0);
    this.setTurn(-1);



    this.startGame=function(ai1_id,ai2_id){
	var board,i,j;
	for(i=0;i<this.imgelm.length;i++){
	    for(j=0;j<this.imgelm[i].length;j++){
		this.imgelm[i][j].setcolorall(-1);
	    }
	}
	board=new NU.ooeg.priv.clas.Board(this.p2polyhedron.polyhedron,[[],[]],0);

	this.referee=new NU.ooeg.priv.clas.Referee(board,ai1_id,ai2_id,this);
	this.referee.start_game();
    };
    this.ai_list=ai_list;
};



NU.ooeg.priv.clas.CellElement = function(cx,cy,cell,parent){
    var self;
    self=this;

    this.cx=cx;
    this.cy=cy;
    this.cell=cell;
    this.parent=parent;
    this.color=-1;
    this.rootelm = document.createElement("div");


    var img;
    img=document.createElement("img");
    img.setAttribute("src",NU.ooeg.publ.cons.src_null);
    img.setAttribute("draggable",false);
    img.style.position="absolute";
    img.style.left=(cx-35)+"px";
    img.style.top=(cy-40)+"px";
    img.style.zIndex=2;
    this.highlightimgF=img;
    this.rootelm.appendChild(img);

    var img;
    img=document.createElement("img");
    img.setAttribute("src",NU.ooeg.publ.cons.src_null);
    img.setAttribute("draggable",false);
    img.style.position="absolute";
    img.style.left=(cx-35)+"px";
    img.style.top=(cy-40)+"px";
    img.style.zIndex=4;    
    this.highlightimgE=img;
    this.rootelm.appendChild(img);


    var img;
    img=document.createElement("img");
    img.setAttribute("src",NU.ooeg.publ.cons.src_frame);
    img.setAttribute("draggable",false);
    img.style.position="absolute";
    img.style.left=(cx-35)+"px";
    img.style.top=(cy-40)+"px";
    img.style.zIndex=6;
    this.frameimg=img;
    this.rootelm.appendChild(img);

    var img;
    img=document.createElement("img");
    img.setAttribute("src",NU.ooeg.publ.cons.src_null);
    img.setAttribute("draggable",false);
    img.style.position="absolute";
    img.style.left=(cx-35)+"px";
    img.style.top=(cy-40)+"px";
    img.style.zIndex=8;
    this.coloringimg=img;
    this.rootelm.appendChild(img);


    this.setColor = function(o){
	this.color=o;
	switch (o){
	case 0:
	    this.coloringimg.setAttribute("src",NU.ooeg.publ.cons.src_blue);
	    break;
	case 1:
	    this.coloringimg.setAttribute("src",NU.ooeg.publ.cons.src_red);
	    break;
	default:
	    this.coloringimg.setAttribute("src",NU.ooeg.publ.cons.src_null );
	    break;
	}
    };
    this.setcolorall = function(o){
	var i;
	for(i=0;i<this.equivalentCell.length;i++){
	    this.equivalentCell[i].setColor(o);
	}
    };


    this.setHighlight = function(ishighlight){
	if(ishighlight){
	    this.highlightimgF.setAttribute("src",NU.ooeg.publ.cons.src_highlightface);
	    this.highlightimgE.setAttribute("src",NU.ooeg.publ.cons.src_highlight);
	}else{
	    this.highlightimgF.setAttribute("src",NU.ooeg.publ.cons.src_null);
	    this.highlightimgE.setAttribute("src",NU.ooeg.publ.cons.src_null);
	}
    };

    this.highlightall = function(){
	var i;
	for(i=0;i<this.equivalentCell.length;i++){
	    this.equivalentCell[i].setHighlight(1);
	}
    };
    this.unhighlightall = function(){
	var i;
	for(i=0;i<this.equivalentCell.length;i++){
	    this.equivalentCell[i].setHighlight(0);
	}
    };
    this.appendEquivalentCell = function(imgelm){
	this.equivalentCell[this.equivalentCell.length]=imgelm;
    }
    this.equivalentCell=[];
    this.appendEquivalentCell(this);


    this.getHtmlElement = function(){
	return this.rootelm;	
    };

    this.getScopeShape = function(){
	return "poly";
    };
    this.getScopeCoord = function(){
	var x,y;
	x=this.cx;
	y=this.cy;
	return [x-26,y-15,x-26,y+15,x,y+30,x+26,y+15,x+26,y-15,x,y-30,x-26,y-15];
    };
    this.getAreaElement = function(){
	var area,i,cs;
	area=document.createElement("area");
	area.setAttribute("shape",this.getScopeShape());
	c=this.getScopeCoord();
	cs="";
	for(i=0;i<c.length;i++){
	    if(i>0){
		cs=cs+",";
	    }
	    cs=cs+c[i];
	}
	area.setAttribute("coords",cs);
	area.actiontips={};
	area.actiontips.self=self;
	area.setAttribute("onClick",'this.actiontips.self.parent.referee.input_and_continue(this.actiontips.self.cell);');

	area.setAttribute("onMouseOver",'this.actiontips.self.highlightall()');
	area.setAttribute("onMouseOut",'this.actiontips.self.unhighlightall()');
	return area;
    }

    this.getMaxX = function(){
	return this.cx+26;
    };
    this.getMaxY = function(){
	return this.cy+30;
    };
    this.getMinX = function(){
	return this.cx-26;
    };
    this.getMinY = function(){
	return this.cy-30;
    };

};


